fl
    1
     2
15 constant _sd_cs
16 constant _sd_di        \ connected SD's di
17 constant _sd_clk
18 constant _sd_do        \ connected SD's do


1 _sd_cs lshift constant _sd_csm
1 _sd_di lshift constant _sd_dim 
1 _sd_clk lshift constant _sd_clkm
1 _sd_do lshift constant _sd_dom

: _sd_cs_out _sd_cs pinout ;
: _sd_di_out _sd_di pinout ;
: _sd_clk_out _sd_clk pinout ;
: _sd_do_in _sd_do pinin ;

: _sd_cs_out_l _sd_csm _maskoutlo ;
: _sd_cs_out_h _sd_csm _maskouthi ;
: _sd_di_out_l _sd_dim _maskoutlo ;
: _sd_di_out_h _sd_dim _maskouthi ;
: _sd_clk_out_l _sd_clkm _maskoutlo ;
: _sd_clk_out_h _sd_clkm _maskouthi ;

wvariable tmp
wvariable tmp1
wvariable time_value 0 c, a c, c c, d c, f c, 14 c, 19 c, 1e c, 23 c, 28 c, 2d c, 32 c, 37 c, 3c c, 46 c, 50 c, 
wvariable time_unit 1 c, a c, 64 c, 1 c, a c, 64 c, 1 c, a c,
wvariable rate_unit 64 c, 1 c, a c, 64 c,
wvariable buff_ptr
wvariable sd_buf

wvariable sdhc
wvariable ccs
wvariable first_sector
wvariable byte/sector
wvariable sector/cluster
wvariable reserve_sector
wvariable num_fat
wvariable root_entry
variable sector/fat
variable total_sector
variable rootCluster
 
variable BTB_addr
variable FAT_addr
variable RDE_addr
variable USER_addr
 
: sd_shift_out
8 0 do
     dup 1 7 i - lshift and  
     0> if _sd_di_out_h else _sd_di_out_l then
     _sd_clk_out_l _sd_clk_out_h                      
     loop
     drop
;
: sd_shift_in
0
8 0 do
     _sd_clk_out_l _sd_clk_out_h                      
     ina COG@ _sd_dom and 0> if 1+ then
     1 lshift   
     loop
     1 rshift
; 

: dummy ff sd_shift_out ;          \ dummy 8clock

\ inititialization for SD-Card
: sd_init
_sd_di_out _sd_di_out_h
_sd_clk_out _sd_clk_out_h
_sd_do_in
_sd_cs_out _sd_cs_out_h
0 sdhc W!  
0 ccs W!
0 tmp W!
dictend W@ 200 - sd_buf W!

4a 0 do                  \ 74 clock
     _sd_clk_out_l
     _sd_clk_out_h
     loop
_sd_cs_out_l

40 sd_shift_out                    \ CMD0
0 4 0 do dup sd_shift_out loop drop
95 sd_shift_out                    \ CRC                  
begin sd_shift_in 1 = if 1 
                      else tmp dup W@ 1+ swap W! tmp W@ 100 = if ." error: no card" cr cr exit 
                                                              else 0 
                                                              then 
                      then 
until
dummy

48 sd_shift_out                    \ CMD8
0 2 0 do dup sd_shift_out loop drop
1 sd_shift_out
aa sd_shift_out
87 sd_shift_out

\ Response for CMD8
begin sd_shift_in dup 1 = if drop 1 
                                else 5 = if begin
                                               77 sd_shift_out                    \ CMD55
                                               0 4 0 do dup sd_shift_out loop drop
                                               1 sd_shift_out
                                               3 0 do sd_shift_in drop loop        \ skip response
                                               dummy
                                               69 sd_shift_out                    \ ACMD41
                                               0 4 0 do dup sd_shift_out loop drop
                                               1 sd_shift_out
                                               5 0 do sd_shift_in 0= if 4 seti 1 else i 4 = if 0 then then loop
                                               dummy
                                            until
                                            ." SDSC initialize success" cr cr
                                            exit
                                          then
                                          0 
                                then 
until

cr 
2 0 do sd_shift_in drop loop
sd_shift_in 
sd_shift_in 
aa = if 1 = if 1 else 0 then else drop 0 then
if 
     begin
          77 sd_shift_out                    \ CMD55
          0 4 0 do dup sd_shift_out loop drop
          1 sd_shift_out
          3 0 do sd_shift_in drop loop        \ skip response
          dummy

          69 sd_shift_out                    \ ACMD41
          40 sd_shift_out
          0 3 0 do dup sd_shift_out loop drop
          1 sd_shift_out
          5 0 do sd_shift_in 0= if 4 seti 1 else i 4 = if 0 then then loop
          dummy
     until
     7a sd_shift_out                    \ CMD58
     0 4 0 do dup sd_shift_out loop drop
     1 sd_shift_out
     begin sd_shift_in 0= until
     sd_shift_in                        \ Get CardCapacityStatus of OCR
     4 0 do sd_shift_in drop loop
     dummy
     40 and 0= if 0 ccs W! else 1 ccs W! then
          
else
     begin
          77 sd_shift_out                    \ CMD55
          0 4 0 do dup sd_shift_out loop drop
          1 sd_shift_out
          3 0 do sd_shift_in drop loop        \ skip response
          dummy

          69 sd_shift_out                    \ ACMD41
          0 4 0 do dup sd_shift_out loop drop
          1 sd_shift_out
          5 0 do sd_shift_in 0= if 4 seti 1 else i 4 = if 0 then then loop
          dummy
     until                         

then
     49 sd_shift_out                    \ CMD9
     0 4 0 do dup sd_shift_out loop drop
     1 sd_shift_out
     dummy
     begin sd_shift_in 0= until
     dummy
     begin sd_shift_in fe = until      \ start-byte for data token
     sd_shift_in
     f 0 do sd_shift_in drop loop         \ data block
     begin sd_shift_in ff = until      \ drop crc          
     dummy
     40 and 40 = if 1 sdhc W! ." SDHC initialize success" cr cr else ." SDSC initialize success" cr cr then
 _sd_cs_out_h
;

\ set buff_ptr to top address of sd_buf
: clear_buff_ptr  sd_buf W@ buff_ptr W! ; 
\ increment buff_ptr   
: buff_ptr+1 buff_ptr W@ 1+ buff_ptr W! ;

\ get sd's block data to sd-buf's area
\    ( address -- )  <-- SDSC
\    ( sector -- )   <-- SDHC on ccs=1
\    ( address -- )  <-- SDHC on ccs=0
: block_read  
4 0 do dup ff and swap 8 rshift loop drop
_sd_cs_out_l
51 sd_shift_out                    \ CMD17 Single Block read
 sd_shift_out
 sd_shift_out
 sd_shift_out
 sd_shift_out
1 sd_shift_out                    \ CRC
begin sd_shift_in 0= until
dummy
begin sd_shift_in fe = until      \ start-byte for data token
clear_buff_ptr  
200 0 do sd_shift_in buff_ptr W@ C! buff_ptr+1 loop
begin sd_shift_in ff = until                          \ drop crc

dummy      
begin sd_shift_in ff = until      \ drop crc          
dummy
_sd_cs_out_h
;

: collect_info      \ collect sd's information 
0 block_read  
clear_buff_ptr
buff_ptr W@ 1c6 + W@ 
buff_ptr W@ 1c8 + W@ 10 lshift or dup first_sector W!

\ 200 * block_read
ccs W@ if block_read else 200 * block_read then
clear_buff_ptr
buff_ptr W@ b + C@ buff_ptr W@ c + C@ 8 lshift or byte/sector W!
buff_ptr W@ d + C@ sector/cluster W!
buff_ptr W@ e + W@ reserve_sector W!
buff_ptr W@ 10 + C@ num_fat W!
buff_ptr W@ 11 + C@ buff_ptr W@ 12 + C@ 8 lshift or root_entry W!
sdhc W@ if buff_ptr W@ 24 + L@ sector/fat L!
        else buff_ptr W@ 16 + W@ sector/fat L!
        then
buff_ptr W@ 20 + L@ total_sector L!
buff_ptr W@ 2c + L@ rootCluster L!

sdhc W@ if
            first_sector W@  BTB_addr L!
            first_sector W@ reserve_sector W@ + FAT_addr L!
            num_fat W@ sector/fat W@ * FAT_addr L@ + RDE_addr L!
          \  root_entry W@ 20 * byte/sector W@ u/ RDE_addr L@ + USER_addr L!
            RDE_addr L@ USER_addr L!
            ccs W@ 0 = if
                           BTB_addr L@ byte/sector W@ * BTB_addr L!
                           FAT_addr L@ byte/sector W@ * FAT_addr L!
                           RDE_addr L@ byte/sector W@ * RDE_addr L!
                         \  USER_addr L@ 200 * USER_addr L!
                           RDE_addr L@ USER_addr L!
                       then
        else
            first_sector W@ byte/sector W@ * BTB_addr L!
            first_sector W@ reserve_sector W@ + byte/sector W@ * FAT_addr L!
            num_fat W@ sector/fat W@ * byte/sector W@ * FAT_addr L@ + RDE_addr L!
            root_entry W@ 20 * RDE_addr L@ + USER_addr L!
        then
        
        
;

: file_name    \ display filename and extention
8 0 do dup C@ dup 20 > if emit else drop then 1+ loop
." ."
3 0 do dup C@ dup 20 > if emit else drop then 1+ loop
drop
;

: file_name    \ display filename and extention
8 0 do dup C@ dup 20 > if emit else drop then 1+ loop
." ."
3 0 do dup C@ dup 20 > if emit else drop then 1+ loop
drop
;

: card_alive?              \ ( -- t/f )   zero if card is alive
     _sd_cs_out_l
     49 sd_shift_out                    \ CMD9    get csd
     0 4 0 do dup sd_shift_out loop drop
     1 sd_shift_out
     dummy
     0 tmp W!

     begin sd_shift_in 0= 
          tmp W@ 64 > if drop 1 else tmp dup W@ 1+ swap W! then 
     until
     tmp W@ 64 > 
     if
          _sd_cs_out_h
          1
     else      
          dummy
          begin sd_shift_in fe = until       \ start-byte for data token
          10 0 do sd_shift_in drop loop      \ data block
          
          begin sd_shift_in ff = until      \ drop crc
          
          dummy
          _sd_cs_out_h
          0
     then
;
  
\ cluster Num --> sector Num
: cluster_to_sector
2 - sector/cluster W@ *                  \ ( (cluster_num - 2) X sector/cluster )
sdhc W@ if ccs W@ if USER_addr L@ +
                  else USER_addr L@ byte/sector W@ u/ + 
                  then  
        else
            USER_addr L@ byte/sector W@ u/ +   
        then
;


: next_sector       \ get next sector value              
sdhc W@ if ccs W@ 0 = if 200 * then
        else byte/sector W@ *
        then
;

: FAT_read               \ top sector of FAT 
first_sector W@ reserve_sector W@ + 
sdhc W@ if ccs W@ 0 = if 200 * then 
        else drop FAT_addr L@ 
        then
;

: cluster_chain     \ display cluster-chain for sdsc
FAT_read  block_read 
0 tmp W!
dup .         
begin
     2 * dup 200 u/ tmp W@ =               \ same as previous ?
     if sd_buf W@ + W@ dup dup ffff = if 2drop 1
                                    else dup 200 u/ tmp W! . 0
                                    then
     else FAT_read block_read dup 200 * + +
          sd_buf W@ + W@ dup dup ffff = if 2drop 1
                                      else dup 200 u/ tmp W! . 0
                                      then
     then
until
;
  
: cluster_chain_sdhc     \ display cluster-chain for sdhc
FAT_read  block_read 
0 tmp W!
dup .         
begin
     4 * dup 200 u/ tmp W@ =               \ same as previous ?
     if sd_buf W@ + L@ dup dup fffffff and fffffff = if 2drop 1
                                    else dup 200 u/ tmp W! . 0
                                    then
     else FAT_read block_read dup 200 * + +
          sd_buf W@ + L@ dup dup fffffff and fffffff = if 2drop 1
                                      else dup 200 u/ tmp W! . 0
                                      then
     then
until
;

: prev_sector       \ get previous sector value              
sdhc W@ if ccs W@ 0 = if 200 * then
        else byte/sector W@ *
        then
;

\ display characters inside LFN's entry
: disp_char         \ ( RED-entry-address charcter-number offset -- )
rot + swap 0 do dup C@ dup ff < if emit else drop then 2+ loop drop
;

: longname          \ ( RDE-entry-address -- ) display LFN 
begin
     20 -
     dup sd_buf W@ < if tmp W@ 2- prev_sector RDE_addr L@ + block_read drop sd_buf W@ 1e0 + then     \ read out previous sector 
     
     dup 5 1 disp_char dup 6 e disp_char dup 2 1c disp_char
     dup C@ 40 and 40 =    
until
drop
tmp W@ 1- prev_sector RDE_addr L@ + block_read    \ read original-sector
;                

: file_detail         \ (RDE-entry-address on sd_buf -- )
dup dup
\ DIR_Name
." Name                         "
c + C@ 8 and 0= if 8 bounds do i C@ dup 20 = if drop else emit then loop                 \ upper

                else 8 bounds do i C@ dup 20 = if drop else 20 or emit then loop         \ lower
                then
." ."
dup dup 8 + swap 
c + C@ 10 and 0= if 3 bounds do i C@ dup 20 = if drop else emit then loop            \ upper

                     else 3 bounds do i C@ dup 20 = if drop else 20 or emit then loop    \ lower
                     then
dup 6 + C@ 7e = if cr ."                        LFN:  " dup longname then        
cr cr
       
{  
dup b +       \ get attribute's address
\ DIR_Attr
." Attribute                    "
C@ dup 1 and 1 = if ." READ_ONLY " then                  
dup 2 and 2 = if ." HIDDEN  " then
dup 4 and 4 = if ." SYSTEM  " then
dup 8 and 8 = if ." VOLUME_ID  " then
dup 10 and 10 = if ." DIRECTORY  " then
dup 20 and 20 = if ." ARCHIVE  " then
cr cr

." Type                         "
10 and 10 = if ." Directory" else ." File" then
cr cr

\ DIR_CrtTime
." Create Time                  "
dup e + W@
dup f800 and b rshift dup 0= if ." 00" drop 
                             else dup a < if ." 0" then to_decimal 
                             then ." :"
dup 7e0 and 5 rshift dup 0= if ." 00" drop 
                            else dup a < if ." 0" 
                            then to_decimal then ." :"
dup d + 
C@ 63 > if 1 else 0 then swap 
1f and 2 * + dup 0= if ." 00" drop 
                    else dup a < if ." 0" 
                                 then 
                                 to_decimal 
                    then
." ." 
dup d + C@ dup 63 > if 64 - then 
to_decimal 
cr cr
 
\ DIR_CtrDate
." Create date                  "
dup 10 + W@
\ buff_ptr W@ 10 + W@
dup fe00 and 9 rshift 7bc + to_decimal ." /"
dup 1e0 and 5 rshift to_decimal ." /"
1f and dup 0= if ." 00" drop else to_decimal then
cr cr

\ DIR_LastAccDate
." Last Access Date             "
dup 12 + W@
dup fe00 and 9 rshift 7bc + to_decimal ." /"
dup 1e0 and 5 rshift to_decimal ." /"
1f and dup 0= if ." 00" drop else to_decimal then
cr cr

\ DIR_WrtTime
." Update Write time            "
dup 16 + W@
dup f800 and b rshift dup 0= if ." 00" drop else dup a < if ." 0" then to_decimal then ." :"
dup 7e0 and 5 rshift dup 0= if ." 00" drop else dup a < if ." 0" then to_decimal then ." :"
1f and 2 * dup 0= if ." 00" drop else dup a < if ." 0" then to_decimal then 
cr cr

\ DIR_WrtDate
." Update Write date            "
dup 18 + W@
dup fe00 and 9 rshift 7bc + to_decimal ." /"
dup 1e0 and 5 rshift to_decimal ." /"
1f and dup 0= if ." 00" drop else to_decimal then
cr cr

\ DIR_FileSize
." File Size                    "
dup 1c + L@ conversion               
cr cr                                                 \ DIR_FileSize
}

\ DIR_FirstCluster
." Cluster chain(hex)         " 
1a + W@ dup 0>
sdhc W@
if
     if cluster_chain_sdhc else drop then
else                                      
     if cluster_chain else drop then
then                                              
cr cr
;

: search       \ search file's line number
RDE_addr L@ block_read
1 tmp W!
\ tmp1          \ input line number
sd_buf W@ 
begin
     dup C@ e5 = if 20 + dup sd_buf W@ 1ff + > if drop tmp W@ next_sector RDE_addr L@ +  \ byte/sector W@ * RDE_addr L@ + 
                                           block_read tmp dup W@ 1+ swap W! sd_buf W@
                                        then 0
                  else dup b + C@ f <> if tmp1 W@ 1 = if file_detail 1
                 
                                                     else tmp1 dup W@ 1- swap W!
                                                       20 + dup sd_buf W@ 1ff + > if
                                                  \     drop tmp W@ byte/sector W@ * RDE_addr L@ +                                                  
                                                                                drop tmp W@ next_sector RDE_addr L@ +
                                                                                block_read tmp dup W@ 1+ swap W! sd_buf W@
                                                                                then
                                                       0
                                                     then 
                                      else
                                             20 + dup sd_buf W@ 1ff + > if  
                                           \       drop tmp W@ \ byte/sector W@ * RDE_addr L@ +
                                                  drop tmp W@ next_sector RDE_addr L@ + 
                                                  block_read tmp dup W@ 1+ swap W! sd_buf W@ 
                                                  then
                                             0
                                      then  
                 then
until
;

: to_decimal   \ convert hex to 4-digit(decimal)
0 tmp W!
3e8 swap over
4 0 do
     u/mod dup 0> if 1 tmp W! .hex else tmp W@ if 0> .hex else drop then then swap a / swap over
loop
3drop
;

: file    \ display file-list
RDE_addr L@ block_read
1 tmp W!        \ line number 
1 tmp1 W!
sd_buf W@ 
begin
     dup C@ e5 = if 20 + dup sd_buf W@ 1ff + > if drop tmp1 W@ next_sector RDE_addr L@ +  \ byte/sector W@ * RDE_addr L@ + 
                                           block_read tmp1 dup W@ 1+ swap W! sd_buf W@
                                        then 0
                 else dup C@ 0= if 1 
                         else dup b + C@ f <> if tmp dup W@ dup to_decimal ."    " 1+ swap W!
                                                 dup file_name cr
                                              then  
                                              20 + dup sd_buf W@ 1ff + > if  
                                           \      drop tmp1 W@ \ byte/sector W@ * RDE_addr L@ +
                                                  drop tmp1 W@ next_sector RDE_addr L@ + 
                                                  block_read tmp1 dup W@ 1+ swap W! sd_buf W@ 
                                                  then
                                              0
                             then
                 then
until
drop

\ tmp is input line_number+1  if 1, then no file
tmp W@ 
dup 1 > if     
cr ."  Input file number > "
0 tmp1 W!

 begin
     dup
     begin
          key dup 30 < if d = if   tmp1 W@ 0> if   1 else ."  Input file number > " 0 then else 0 then
                    else dup 39 > if drop 0
                                   else  dup emit tmp1 W@ 2 = if 3 0 do drop loop
                                                            0 tmp1 W!
                                                            ."  incorect input" cr 
                                                            ."  Input file number > " 0
                                                                                                                                                 
                                                          else  todigit tmp1 dup W@ 1+ swap W! 0 
                                                          then  
                                then  
                  then
     until
     tmp1 W@ 2 = if swap a * + then dup tmp1 W!
     > if tmp1 W@ 0= if ."  zero is NG!!" cr ."  Input file number > " 0 tmp1 W! 0 
                     else drop 1 
                     then 
       else ."  not match" cr ."  Input file number > " 0 tmp1 W! 0 
       then         
 until
cr cr
search 
else ." no file" cr drop then
;


: sd_fl
card_alive?
if 
     sd_init
     tmp W@ 100 = if exit then
     collect_info 
then

\ display files indide SD and select it and load to RAM
file


;


