fl

15 constant _sd_cs
16 constant _sd_di        \ connected SD's di
17 constant _sd_clk
18 constant _sd_do        \ connected SD's do


1 _sd_cs lshift constant _sd_csm
1 _sd_di lshift constant _sd_dim 
1 _sd_clk lshift constant _sd_clkm
1 _sd_do lshift constant _sd_dom

: _sd_cs_out _sd_cs pinout ;
: _sd_di_out _sd_di pinout ;
: _sd_clk_out _sd_clk pinout ;
: _sd_do_in _sd_do pinin ;

: _sd_cs_out_l _sd_csm _maskoutlo ;
: _sd_cs_out_h _sd_csm _maskouthi ;
: _sd_di_out_l _sd_dim _maskoutlo ;
: _sd_di_out_h _sd_dim _maskouthi ;
: _sd_clk_out_l _sd_clkm _maskoutlo ;
: _sd_clk_out_h _sd_clkm _maskouthi ;

wvariable tmp
wvariable tmp1
wvariable time_value 0 c, a c, c c, d c, f c, 14 c, 19 c, 1e c, 23 c, 28 c, 2d c, 32 c, 37 c, 3c c, 46 c, 50 c, 
wvariable time_unit 1 c, a c, 64 c, 1 c, a c, 64 c, 1 c, a c,
wvariable rate_unit 64 c, 1 c, a c, 64 c,
wvariable buff_ptr
wvariable sd_buf

wvariable sdhc
wvariable ccs
variable first_sector
wvariable byte/sector
wvariable sector/cluster
wvariable reserve_sector
wvariable num_fat
wvariable root_entry
variable sector/fat
variable total_sector
variable rootCluster
 
variable BTB_addr
variable FAT_addr
variable RDE_addr
variable USER_addr
 
: sd_shift_out      \ ( n -- ) send 1byte to SD-CARD 
8 0 do
     dup 1 7 i - lshift and  
     0> if _sd_di_out_h else _sd_di_out_l then
     _sd_clk_out_l _sd_clk_out_h                      
     loop
     drop
;
: sd_shift_in       \ ( -- n) receive 1byte to SD-CARD
0
8 0 do
     _sd_clk_out_l _sd_clk_out_h                      
     ina COG@ _sd_dom and 0> if 1+ then
     1 lshift   
     loop
     1 rshift
; 

: dummy ff sd_shift_out ;          \ ( -- ) send dummy 8clock to SD-CARD

: sd_init      \ ( -- ) initialization for SD-Card
_sd_di_out _sd_di_out_h
_sd_clk_out _sd_clk_out_h
_sd_do_in
_sd_cs_out _sd_cs_out_h
0 sdhc W!  
0 ccs W!
0 tmp W!
dictend W@ 200 - sd_buf W!

4a 0 do                  \ 74 clock
     _sd_clk_out_l
     _sd_clk_out_h
     loop
_sd_cs_out_l

40 sd_shift_out                    \ CMD0
0 4 0 do dup sd_shift_out loop drop
95 sd_shift_out                    \ CRC                  
begin sd_shift_in 1 = if 1 
                      else tmp dup W@ 1+ swap W! tmp W@ 100 = if ." error: no card" cr cr exit 
                                                              else 0 
                                                              then 
                      then 
until
dummy

48 sd_shift_out                    \ CMD8
0 2 0 do dup sd_shift_out loop drop
1 sd_shift_out
aa sd_shift_out
87 sd_shift_out

\ Response for CMD8
begin sd_shift_in dup 1 = if drop 1 
                                else 5 = if begin
                                               77 sd_shift_out                    \ CMD55
                                               0 4 0 do dup sd_shift_out loop drop
                                               1 sd_shift_out
                                               3 0 do sd_shift_in drop loop        \ skip response
                                               dummy
                                               69 sd_shift_out                    \ ACMD41
                                               0 4 0 do dup sd_shift_out loop drop
                                               1 sd_shift_out
                                               5 0 do sd_shift_in 0= if 4 seti 1 else i 4 = if 0 then then loop
                                               dummy
                                            until
                                            ." SDSC initialize success" cr cr
                                            exit
                                          then
                                          0 
                                then 
until

cr 
2 0 do sd_shift_in drop loop
sd_shift_in 
sd_shift_in 
aa = if 1 = if 1 else 0 then else drop 0 then
if 
     begin
          77 sd_shift_out                    \ CMD55
          0 4 0 do dup sd_shift_out loop drop
          1 sd_shift_out
          3 0 do sd_shift_in drop loop        \ skip response
          dummy

          69 sd_shift_out                    \ ACMD41
          40 sd_shift_out
          0 3 0 do dup sd_shift_out loop drop
          1 sd_shift_out
          5 0 do sd_shift_in 0= if 4 seti 1 else i 4 = if 0 then then loop
          dummy
     until
     7a sd_shift_out                    \ CMD58
     0 4 0 do dup sd_shift_out loop drop
     1 sd_shift_out
     begin sd_shift_in 0= until
     sd_shift_in                        \ Get CardCapacityStatus of OCR
     4 0 do sd_shift_in drop loop
     dummy
     40 and 0= if 0 ccs W! else 1 ccs W! then
          
else
     begin
          77 sd_shift_out                    \ CMD55
          0 4 0 do dup sd_shift_out loop drop
          1 sd_shift_out
          3 0 do sd_shift_in drop loop        \ skip response
          dummy

          69 sd_shift_out                    \ ACMD41
          0 4 0 do dup sd_shift_out loop drop
          1 sd_shift_out
          5 0 do sd_shift_in 0= if 4 seti 1 else i 4 = if 0 then then loop
          dummy
     until                         

then
     49 sd_shift_out                    \ CMD9
     0 4 0 do dup sd_shift_out loop drop
     1 sd_shift_out
     dummy
     begin sd_shift_in 0= until
     dummy
     begin sd_shift_in fe = until      \ start-byte for data token
     sd_shift_in
     f 0 do sd_shift_in drop loop         \ data block
     begin sd_shift_in ff = until      \ drop crc          
     dummy
     40 and 40 = if 1 sdhc W! ." SDHC initialize success" cr cr else ." SDSC initialize success" cr cr then
 _sd_cs_out_h
;

\ displar Block(generally 512byte)
\    ( address-value -- )  <-- SDSC
\    ( sector=number -- )  <-- SDHC on ccs=1
\    ( address-value -- )  <-- SDHC on ccs=0
: Block     
4 0 do dup ff and swap 8 rshift loop drop
."      " 10 0 do i . ."  " loop cr
_sd_cs_out_l
51 sd_shift_out                    \ CMD17 Single Block read
 sd_shift_out
 sd_shift_out
 sd_shift_out
 sd_shift_out
1 sd_shift_out                    \ CRC
begin sd_shift_in 0= until
dummy
begin sd_shift_in fe = until      \ start-byte for data token
20 0 do
     i 10 u* dup 10 < if ." 00" . else dup 100 < if ." 0" . else . then then       \ address
     sd_buf W@ 10 0 do dup sd_shift_in swap W! 2+ loop drop       
     sd_buf W@ 10 0 do dup W@ .byte space 2+ loop drop        \ data
     ."   "
     sd_buf W@ 10 0 do dup W@ dup  20 < if ." ." drop else dup  7e > if ." ." drop else emit then then 2 + loop drop    \ ascii
     
     cr
     loop

begin sd_shift_in ff = until      \ drop crc
          
dummy
_sd_cs_out_h
;

\ ( n1 -- n2 ) convert n1(hex) to n2[character(1,2,3,4,5,6,7,8,9,10,11,12)]   
: month        
f and 30 + dup 39 > if dup 3a = if ." 10" drop else dup 3b = if ." 11" drop else ." 12" drop then then else emit then
;

: to_decimal   \ ( n1 -- n2 ) convert hex(n1) to 4-digit(decimal)(n2)
0 tmp W!
2710 swap over 
5 0 do
     u/mod dup 0> if 1 tmp W! .hex else tmp W@ if 0> .hex else drop then then swap a / swap over

loop
3drop
;

: cid     \ ( -- ) displaty cid
." Card IDentification Register(CID)" cr
_sd_cs_out_l
     4a sd_shift_out                    \ CMD10
     0 4 0 do dup sd_shift_out loop drop
     1 sd_shift_out
     dummy
     begin sd_shift_in 0= until
     dummy  
     begin sd_shift_in fe = until     \ start-byte for data token

     ."  ManufactureID      "     
     sd_shift_in .byte cr
     ."  OEM/AppricationID  "
     sd_shift_in sd_shift_in swap emit emit cr
     ."  ProductName        "
     5 0 do sd_shift_in emit loop cr
     ."  ProductRev         "
     sd_shift_in dup 4 rshift .hex ." ." .hex cr
     ."  SerialNumber       "
     4 0 do sd_shift_in .byte loop cr
     ."  ManufacturingDate  "
 
     sd_shift_in 4 lshift sd_shift_in dup 4 rshift rot or 7d0 + to_decimal ." /" month cr
     sd_shift_in drop
     begin sd_shift_in ff = until     \ drop crc
     
     dummy
_sd_cs_out_h
;

: to_decimal_dot    \ ( n1 -- n2 ) convert hex(n1) to 4-digit(decimal)(n2) with dot
0 tmp W!
3e8 swap over
4 0 do
     i 3 = if ." ." then u/mod dup 0> if 1 tmp W! .hex else tmp W@ if 0> .hex else drop then then swap a / swap over
loop
3drop
;

: csd     \ ( -- ) display csd
." Card Specific Data register(CSD)" cr
_sd_cs_out_l
     49 sd_shift_out                    \ CMD9
     0 4 0 do dup sd_shift_out loop drop
     1 sd_shift_out
     dummy
     begin sd_shift_in 0= until
     dummy
     begin sd_shift_in fe = until      \ start-byte for data token

     sd_shift_in drop           \ skip
     ."  Access Time        "
     sd_shift_in dup dup 78 and 3 rshift time_value 2 + + C@     \ access time
     swap 7 and time_unit 2 + + C@ * to_decimal_dot
     7 and dup 3 < if ." nsec" else 6 < if ." usec" else ." msec" then then cr
          
     sd_shift_in drop           \ skip
     ."  Transfer Speed     " 
     sd_shift_in dup dup 78 and 3 rshift time_value 2 + + C@     \ transfer speed
     swap 7 and rate_unit 2 + + C@ * to_decimal_dot
     7 and 0= if ." kbit/s" else ." Mbit/s" then  cr
     
     sd_shift_in drop           \ skip
     ."  Data Block Length  " 
     sd_shift_in f and dup tmp1 W! 1 swap lshift to_decimal ." byte" cr

     sdhc W@ if sd_shift_in drop           \ skip
                sd_shift_in 3f and 10 lshift 
                sd_shift_in 8 lshift or
                sd_shift_in or        
             \   ."  Capacity           "  1+ 200 * 400 * 100000 u/ to_decimal ." Mbyte" cr
                ."  Capacity           "  1+ 200 * 400 u/ to_decimal ." Mbyte" cr
             else 
                ."  Capacity           " 
                sd_shift_in 3 and a lshift          \ C_SIZE 
                sd_shift_in 2 lshift or
                sd_shift_in c0 and 6 rshift or 1 +
                
                sd_shift_in 3 and 1 lshift           \ C_SIZE_MULT
                sd_shift_in 7 rshift or 2 + 
     
                1 swap lshift * 1 tmp1 W@ lshift * 100000 u/ to_decimal ." Mbyte" cr 
             then        
     
     5 0 do sd_shift_in drop loop
     
     begin sd_shift_in ff = until      \ drop crc
          
     dummy
_sd_cs_out_h
; 

\ set buff_ptr to top address of sd_buf
: clear_buff_ptr  sd_buf W@ buff_ptr W! ; 
\ increment buff_ptr   
: buff_ptr+1 buff_ptr W@ 1+ buff_ptr W! ;


\ copy sd's block data to sd-buf's area
\    ( address-value -- )  <-- SDSC
\    ( sector-number -- )  <-- SDHC on ccs=1
\    ( address-value -- )  <-- SDHC on ccs=0
: block_read  
4 0 do dup ff and swap 8 rshift loop drop
_sd_cs_out_l
51 sd_shift_out                    \ CMD17 Single Block read
 sd_shift_out
 sd_shift_out
 sd_shift_out
 sd_shift_out
1 sd_shift_out                    \ CRC
begin sd_shift_in 0= until
dummy
begin sd_shift_in fe = until      \ start-byte for data token
clear_buff_ptr  
200 0 do sd_shift_in buff_ptr W@ C! buff_ptr+1 loop
begin sd_shift_in ff = until                          \ drop crc

dummy      
begin sd_shift_in ff = until      \ drop crc          
dummy
_sd_cs_out_h
;

: collect_info      \ ( -- ) collect sd's information 
0 block_read  
clear_buff_ptr
buff_ptr W@ 1c6 + W@ 
buff_ptr W@ 1c8 + W@ 10 lshift or dup first_sector L!
                      
ccs W@ if block_read else 200 * block_read then
clear_buff_ptr
buff_ptr W@ b + C@ buff_ptr W@ c + C@ 8 lshift or byte/sector W!
buff_ptr W@ d + C@ sector/cluster W!
buff_ptr W@ e + W@ reserve_sector W!
buff_ptr W@ 10 + C@ num_fat W!
buff_ptr W@ 11 + C@ buff_ptr W@ 12 + C@ 8 lshift or root_entry W!
sdhc W@ if buff_ptr W@ 24 + L@ sector/fat L!
        else buff_ptr W@ 16 + W@ sector/fat L!
        then
buff_ptr W@ 20 + L@ total_sector L!
buff_ptr W@ 2c + L@ rootCluster L!

sdhc W@ if
            first_sector L@  BTB_addr L!
            first_sector L@ reserve_sector W@ + FAT_addr L!
            num_fat W@ sector/fat W@ * FAT_addr L@ + RDE_addr L!
            RDE_addr L@ USER_addr L!
            ccs W@ 0 = if
                           BTB_addr L@ byte/sector W@ * BTB_addr L!
                           FAT_addr L@ byte/sector W@ * FAT_addr L!
                           RDE_addr L@ byte/sector W@ * RDE_addr L!
                           RDE_addr L@ USER_addr L!
                       then
        else
            first_sector L@ byte/sector W@ * BTB_addr L!
            first_sector L@ reserve_sector W@ + byte/sector W@ * FAT_addr L!
            num_fat W@ sector/fat W@ * byte/sector W@ * FAT_addr L@ + RDE_addr L!
            root_entry W@ 20 * RDE_addr L@ + USER_addr L!
        then
                
;

: conversion   \ ( n1 -- n2) convert byte(n1) to Mbyte/kbyte/byte(n2)
dup 0<> 
if
     100000 u/mod dup 0> if to_decimal ." M" drop 
                         else drop 400 u/mod dup 0> if to_decimal ." k" drop
                                                    else drop to_decimal
                                                    then
                         then
else
     drop ." 0"
then
 ." byte"         
;

: file_name    \ display filename and extention
8 0 do dup C@ dup 20 > if emit else drop then 1+ loop
." ."
3 0 do dup C@ dup 20 > if emit else drop then 1+ loop
drop
;

: card_alive?              \ ( -- t/f )   zero if card is alive
     _sd_cs_out_l
     49 sd_shift_out                    \ CMD9    get csd
     0 4 0 do dup sd_shift_out loop drop
     1 sd_shift_out
     dummy
     0 tmp W!

     begin sd_shift_in 0= 
          tmp W@ 64 > if drop 1 else tmp dup W@ 1+ swap W! then           
     until
     tmp W@ 64 > 
     if
          _sd_cs_out_h
          1
     else      
          dummy
          begin sd_shift_in fe = until       \ start-byte for data token
          10 0 do sd_shift_in drop loop      \ data block
          
          begin sd_shift_in ff = until      \ drop crc
          
          dummy
          _sd_cs_out_h
          0
     then
;
  
: MBR     \ ( -- ) display MBR
."  MBR(Master Boot Record)" ."  Sector:0x0 " ." Address:0x0" cr cr
0 Block
;
: BTB     \ ( -- ) display BTB
."  BTB(BIOS Parameter Block)" ."  Sector:0x" first_sector L@ dup . 
." Address:0x" 
sdhc W@ if dup 200 * . ccs W@ 0 = if 200 * then
        else drop BTB_addr L@ dup .
        then
 cr cr Block
;
: FAT     \ ( -- ) display FAT
."  FAT(File Allocation Table)" ."  Sector:0x" first_sector L@ reserve_sector W@ + dup .
." Address:0x" 
sdhc W@ if dup 200 * . ccs W@ 0 = if 200 * then
        else drop FAT_addr L@ dup .
        then       
cr cr Block
;
: RDE     \ ( -- ) display RDE
."  RDE(Root Directory Entry)" ."  Sector:0x" first_sector L@ reserve_sector W@ + num_fat W@ sector/fat W@ * + dup .
." Address:0x" 
sdhc W@ if dup 200 * . ccs W@ 0 = if 200 * then
        else drop RDE_addr L@ dup .
        then
cr cr Block
;

: info    \ ( -- ) display information (WORD"collect_info")
." SD-card Information"  cr
."  type               "
sdhc W@ if ." SDHC" else ." SDSC" then cr
."  firstSectorNumbers 0x" first_sector L@ . cr
."  bytePerSector      0x" byte/sector W@ . cr
."  sectorsPerCluster  0x" sector/cluster W@ . cr
."  reservedSectors    0x" reserve_sector W@ . cr
."  numberOfFATS       0x" num_fat W@ . cr
sdhc W@ if ."  rootDirCluster     0x" rootCluster L@ . cr
        else  ."  rootEntries        0x" root_entry W@ . cr              
        then
."  sectorsPerFAT      0x" sector/fat W@ . cr
."  bigTotalSectors    0x" total_sector L@ . cr

;

: cluster_to_sector           \ ( cluster-number --> sector-number)
2 - sector/cluster W@ *                  \ ( (cluster_num - 2) X sector/cluster )
sdhc W@ if ccs W@ if USER_addr L@ +
                  else USER_addr L@ byte/sector W@ u/ + 
                  then  
        else
            USER_addr L@ byte/sector W@ u/ +   
        then
;

